
(*
Package Info
*)
(*
:Name: jutils`
*)
(*
:Context: jutils`
*)
(*
:Title: jutils miscellaneous functions
*)
(*
:Summary:
	these are just functions i personally use
	not necessarily meant to be libraried

	see changelog of PeriodicTables, few
	
	see Warnings about CreateModule if used
*)
(*
:Author: John D. Hendrickson
*)
(*
:Mathematica Version 4.0
*)
(*
:Package Version: 1.0.4
*)
(*
:History:
*)
(*
:Keywords:
*)
(*
:Requirements: should be none.  has Needs but should be same all mm ver.
*)
(*
:Copyright: public domain
*)
(*
:Warnings:
	CreateModule is a nice conept but...
	I'm unsure if it has effects on front-end
		it could cause problems saving but i
		believe not.  but save your work until
		you are comfortable with it.
	I'm doubly unsure if mm v.9 apache stuff works
	enough the same.
*)
(*
Package and Setup Notes
*)
(*
Opening project , Avoiding direcory , currnt project dir.
*)
(*
<< jutils`
*)
(*
If .nb files move around in OS direcories any directory names in notebooks \
break.  Mathematica Directory[] tools are a nuisance to fix such \
dependancies.  the above was suggested to me and works great: shouldn't need \
any use of ln(1) to find init.m
*)
(*
# ln -s ~/jutils/Documentation/English/jutils.help.nb to :
~/.Mathematica/4.0/AddOns/Applications/jutils/Documentation/English/jutils.\
help.nb
*)
(*
is created below and place automatically (see Private) but unlikely to be \
sucessful (you have to change directory but i won't symbolize it)

browsercategory >> "~/jutils/BrowserCategories.m";
browsercategory >> \
"~/.Mathematica/4.0/AddOns/Applications/jutils/Documentation/English/\
BrowserCategories.m";
*)
(*
# ln -s ~/.Mathematica/4.0/AddOns/Applications/jutils/Documentation/English/\
BrowserCategories.m
*)
(*
ln init.m can be to ~/.Mathematica/4.0/AddOns/Applications/jutils/init.m
*)
(*
Convenient is a mm palette you don't want.

Place this so palette could just as well launch jutils` (or use menu to add \
it as palette)
	{~/.Mathematica/4.0/FrontEnd/Palettes/Convenient.nb}	
*)
(*
fyi, $Path is search path which can be changed to include whatever the \
current project (area) is.
*)
(*
$Path=Union[{$HomeDirectory<>"/math/Mathematica/chem"},$Path];
*)
(*
IMPORTANT NOTE
*)
(*
mathematica 4.0 will slowly corrupt the save of an.nb that also saves as.m \
(use of save as special "package format") if the following is not done :
*)
(*
mathematica treats .nb that get saved as package specially
	* remember to "delete all output" from kernel menu
	* cells with tags "(local) In[xxx]:" need to be bumped so the tag disappears
	  (bump: insert a return then delete it and tags will dissapear)
	* insure init code is marked as "initialization cell" and that nothing
	  else is marked as evaluatable which should not be
*)
(*
Package jutils
*)
(*
Needs
*)
(*
local needs
*)
(*
Needs["Months`"];
*)
(*
Needs["Miscellaneous`Calendar`"];
*)
(*
DeclarePackage["Utilities`Package`",{"FindPackages","Annotation"}];
*)
(*
DeclarePackage["context`", \!\(TraditionalForm\`{\)"\!\(\*FormBox[
  SubscriptBox["\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"name\\\\\\\"\\\", \
\\\"TI\\\"]\\)\"\>", "1"], TraditionalForm]\)", "\!\(\*FormBox[
  SubscriptBox["\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"name\\\\\\\"\\\", \
\\\"TI\\\"]\\)\"\>", 
    "2"], TraditionalForm]\)", \[Ellipsis] \!\(TraditionalForm\`}\)]
	loads pkg if name is ever incurred , also Stub attrib on name can do this
*)
(*
BeginPackage
*)
BeginPackage["jutils`"];
(*
Mesages
*)
Off[General::"spell"];
jutils::"usage" = "some utils";
true::usage = "True";
false::usage = "True";
groupadjacent::usage = 
    "Splits list into groups using adjacency and rule given by arguments \
testeach and testboth.";
CreateModule::usage = 
    "CreateModule[f[x_], body, opts] assigns function definition for f to \
body collected by CombinCells.  See Help.";
CombineCells::usage = 
    "CombineCells[opts] combines cells found between last two text lines that \
text BoundryCell is found.  See Help.";
Runto::usage = 
    "RunTo[opts] runs from text line RunToBoundryCell is found on to current \
line.  See Help.";
padit::usage = 
    "padit[str,n] makes str width n by padding or removing on right.";
paditl::usage = 
    "padit[str,n] makes str width n by padding or removing on left.";
paditc::usage = 
    "paditc[str,n] centers string within greater width n.  ignores spaces \
given in str as intended.  unlike padit will not chop str.";
ToEach::usage = "ToEach[a,b] is a list of  each a in with b";
ToEach2::usage = "ToEach[a,b] is a list of  each a in with b";
ToEach3::usage = "ToEach[a,b] is a list of  each a in with b";
list::usage = "list[f,i] makes fun listable for i";
listc::usage = "listc[f,i] lists fun against all names in context i.";
jm::usage = "jr[m_:0] returns to a cell jm[] marked.";
jmark;
jm::usage = "jm[m_:0] marks a cell (jr[] returns to it)";
jr::usage = "jm[m_:0] marks a cell (jr[] returns to it)";
NbOpenAsk::usage = "Opens nb using file dialog box.";
NbAsk::usage = "File Dialog tool: Fsb, NbOpenAsk";
Fsb::usage = "Opens file dialog, returns string to stdout.";
ucc::usage = "rsh cmd output is /tmp/nbasktmpfile";
ucl::usage = "run cmd and ReadList output";
uci::usage = "run cmd and Import output";
(*
are in Months
*)
(*
IncrementToward::usage = 
    "IncrementToward[y,x] increments x toward y in either direction.";
*)
(*
IncrementAway::usage = 
    "IncrementAway[y,x] increments x away from y in either direction.";
*)
(*
IncrementAwayAbove::usage = 
    "IncrementAwayAbove[y,x] increments x away from y going above if a \
direction must first be chosen.";
*)
(*
IncrementAwayBelow::usage = 
    "IncrementAwayBelow[y,x] increments x away from y going below if a \
direction must first be chosen.";
*)
mag::usage = "vector magnitude";
unit::usage = "vector unitary";
midpt::usage = "vector midpt";
(*
convenient - conv`
*)
(*
excuse, for personal launch palette
*)
Begin["conv`"];
conv`jutilnb := NotebookOpen["~/jutils/jutils.nb"];
conv`jhelpnb := NotebookOpen["~/jutils/Documentation/English/jutils.help.nb"];
  
conv`convnb := NotebookOpen["~/math/Mathematica/Palettes/Convenient-nb.nb"];
End[];
(*
	got out of conv`
*)
MUF = Miscellaneous`Units`Private`$ToFundamental;
(*
Expr
*)
(*
note: these don't like being in a package (maybe it's just creatmodule but \
too hard to fix).  even the messages should be outside
*)
(*
createmodule can't be in private these are needed to resolve RunTo dependancy \
(i'm not sure runto must be outside of Private but the other two must be)
*)
(*
true false
*)
true::usage = "True";
false::usage = "False";
true[__] := True;
false[__] := False;
(*
groupadjacent
*)
(*
i wrote this because Split[] is broken - Splits' example for InputForm nubmer \
leeaves a "-" trailing at the end of digits , which is opposite what it says \
it will do.
*)
groupadjacent::usage = 
    "Splits list into groups using adjacency and rule given by arguments \
testeach and testboth.";
groupadjacent[v_List, testboth_, testeach_:SameQ] := Module[{i, j, n, v2, f},
    v2 = {}; n = Length[v]; j = 1;
    While[j <= n,
      i = j;
      While[i < n
          && testeach[v[[i]]]
          && testeach[v[[i + 1]]]
          && testboth[v[[i]]
            , v[[i + 1]]], ++i];
      AppendTo[v2, Take[v, {j, i}]];
      j = i + 1
      ];
    v2
    ]
(*
CreateModule
*)
(*
currently an issue is combining lines with comments interspersed with \
compound expressions
*)
(*
see below
	(* data=body/.Cell[BoxData[x:__],__]->x; *)
This expression becomes value of Global`x if x is defined (else it works).

Would like to know why.  I think it evaluates while pattern matching (in this \
case un-intended).  However that doesn't explain , in my mind , how Global`x \
is ever involved unless there is a problem outside this routine.
*)
Options[CreateModule] = {Vars -> Null, Context -> "", Context2 -> "", 
      Paste -> True};
(*
was nb=SelectedNotebook[]; unsure why
*)
CreateModule[head_, body_, opts___] := 
  Module[{asf, x, i, mb, vb, mbvb, mbvbdata, context, context2, data, cell, 
      vars2, vars, con2, ra, rm, rh, r1, bd, paste},
    asf = AutoScroll -> False;
    vars = Vars /. {opts} /. Options[CreateModule];
    context = Context /. {opts} /. Options[CreateModule];
    context2 = Context2 /. {opts} /. Options[CreateModule];
    paste = Paste /. {opts} /. Options[CreateModule];
    If[vars === Null, vars2 = Names[context <> "*"], vars2 = vars];
    vb = Insert[vars2, ",", Table[{i}, {i, 2, Length[vars2]}]];
    (* data = body /. Cell[BoxData[x : __], __] -> x; *)
    
    data = body[[1]][[1]]; (* should work for above *)
    
    data = data[[1]]; (* outer wrap *)
    (* 
      static form for module is picky and Eval freezes w/o *)
    (* 
      for that reason /. has been /. for static *)
    
    vb = RowBox[Flatten[vb]];
    vb = RowBox[{"{", vb, "}"}];
    ra = Sequence[vb, ",", "\n", Sequence @@ data];
    (* note IndentingNewLine omitted after ra *)
    
    rm = RowBox[ {"Module", "[" , ra , "]" }];
    If[paste === True,
      rh = RowBox[{ToBoxes[head], ":=", rm}];
      , rh = rm;
      ];
    r1 = RowBox[{rh, ";"}];
    bd = BoxData[r1];
    (* Evaluatable -> True prevents CellAutoOverwrite *)
    
    cell = Cell[bd, "Output", CellLabel -> "Gen Mod", GeneratedCell -> True, 
        Evaluatable -> False];
    If[paste === True || paste === Safe,
      nb = EvaluationNotebook[];
      SelectionMove[nb, After, EvaluationCell, asf];
      NotebookWrite[nb, cell];
      If[paste === Safe, Return[]];
      (* SelectionEvaluate[
            nb] does not post until after NotebookEvaluate no matter what is \
tried *)
      SelectionMove[nb, Next, Cell, asf];
      ToExpression[cell[[1, 1]]];
      (* SetOptions[NotebookSelection[nb], Evaluatable -> False]; *)
      , 
      cell
      ]
    ]
(*
CombineCells
*)
Options[CombineCells] = {Paste -> False, Begin -> "BoundryCell", 
      End -> "BoundryCell", Len -> 500, Direction -> -1, Skip -> True};
(*
was nb=SelectedNotebook[];  unsure why
*)
CombineCells[opts___] := 
    Module[{data, data2, data3, asf, nb, str, done, begin, end, len, before, 
        previous, i, j, a, b, c, d, e, x, y, z, skip},
      paste = Paste /. {opts} /. Options[CombineCells];
      begin = Begin /. {opts} /. Options[CombineCells];
      end = End /. {opts} /. Options[CombineCells];
      len = Len /. {opts} /. Options[CombineCells];
      dir = Direction /. {opts} /. Options[CombineCells];
      skip = Skip /. {opts} /. Options[CombineCells];
      before = Before; previous = Previous;
      If[dir == 1, before = After; previous = Next];
      asf = AutoScroll -> False;
      done = False; p1 = p2 = data4 = data3 = data2 = ""; data = {};
      nb = EvaluationNotebook[];
      SelectionMove[nb, before, EvaluationCell, asf];
      SelectionMove[nb, previous, Cell, asf];
      SelectionMove[nb, All, CellContents, asf];
      data2 = NotebookRead[nb];
      str = ToString[data2];
      If[ data2 =!= end, Print["no end"]; Return[]];
      SelectionMove[nb, previous, Cell, asf];
      SelectionMove[nb, All, CellContents, asf];
      i = 0; done = False; data3 = data2 = ""; data = "";
      SelectionMove[nb, All, Cell, asf];
      While[done === False && ++i < len,
        
        data3 = NotebookRead[nb];
        data2 = data3[[1]];
        data3 = Drop[data3, 1];
        
        If[skip && Length[Cases[data3, "Output" | "Print" | "Message"]] > 0,
          SelectionMove[nb, previous, Cell, asf];
          Continue[]
          ];
        
        str = ToString[data2];
        If[str === begin, done = True,
          j = Length[data2];
          If[j > 0 || \[Not] skip,
            If[j > 0 && data2[[0]] == BoxData, data2 = data2[[1]]];
            If[Length[Position[data2, RowBox]] > 1, data2 = data2[[1]]];
            data3 = data2 /.\[InvisibleSpace]
                {a : ___, 
                    RowBox[{RowBox[{b : ___}], h : ___, x : ";", d : ___}], 
                    c : ___} ->
                  {a, RowBox[{b}], x, h, d, c};
            data2 = data3;
            data = Sequence[data2, "\n", data];
            ];
          SelectionMove[nb, previous, Cell, asf];
          ];
        ];
      data = Flatten[Drop[List[data], -1]];
      (* stripped each outer for ea above *)
      data = RowBox[data];
      data = Cell[BoxData[data], "Output"];
      SelectionMove[nb, After, EvaluationCell, asf];
      If[done === False  , Print["no begin"]; Return[]];
      If[paste === True,
        NotebookWrite[nb, data];
        SelectionMove[nb, Previous, Cell, asf];
        SelectionMove[nb, All, Cell, asf];
        SetOptions[NotebookSelection[nb], CellLabel -> "Gen Mod", 
          GeneratedCell -> True, Evaluatable -> False ];
        SelectionMove[nb, After, Cell, asf];
        , data
        ]
      ];
(*
RunTo
*)
(*
really I'd rather use Input[ n - m ] however that won't work in many \
situations
*)
Options[RunTo] = {Paste -> False, Begin -> "RunToBoundryCell", 
      End -> "RunToBoundryCell", Len -> 500, Direction -> -1, Skip -> True};
RunTo[opts___] := 
  Module[{data, data2, data3, asf, nb, str, done, begin, end, len, before, 
      previous, i, j, a, b, c, d, f, g, h, w, x, y, z, skip},
    paste = Paste /. {opts} /. Options[RunTo];
    begin = Begin /. {opts} /. Options[RunTo];
    end = End /. {opts} /. Options[RunTo];
    len = Len /. {opts} /. Options[RunTo];
    dir = Direction /. {opts} /. Options[RunTo];
    skip = Skip /. {opts} /. Options[RunTo];
    before = Before; previous = Previous;
    If[dir == 1, before = After; previous = Next];
    asf = AutoScroll -> False;
    done = False; p1 = p2 = data4 = data3 = data2 = ""; data = {};
    nb = SelectedNotebook[];
    SelectionMove[nb, before, EvaluationCell, asf];
    i = 0; done = False; data3 = data2 = ""; data = "";
    SelectionMove[nb, previous, Cell, asf];
    (* scan back to Boundry *)
    z = 0;
    While[done === False && ++i < len,
      data3 = NotebookRead[nb];
      data2 = data3[[1]];
      str = ToString[data2];
      If[str === begin, done = True ];
      If[Length[data3] > 1 && 
          StringMatchQ[ToString[Rest[data3]], "*Input,*"], ++z ];
      SelectionMove[nb, previous, Cell, asf];
      ];
    SelectionMove[nb, next, Cell, asf];
    SelectionMove[nb, next, Cell, asf];
    data3 = NotebookRead[nb];
    SelectionMove[nb, All, Cell, asf];
    (* scan to start , eval any Input cell *)
    j = 0; a = 0; b = z; c = i;
    While[++j < i && j < len && a < z,
      data3 = NotebookRead[nb];
      If[Length[data3] > 1 && StringMatchQ[ToString[First[data3]],
            "*RunTo*"], Print["stop: found RunTo before finish"]; Break[]];
      If[Length[data3] > 1 && 
          StringMatchQ[ToString[Rest[data3]], "*Input,*"],
        SelectionEvaluate[nb, asf];
        If[a == 0, str = ToString[data3[[3]]]];
        d = ToString[data3[[3]]];
        ++a;
        (* note selection auto moves past output *)
        (* 
          note Evaluation cell is Runto still *)
        ];
      SelectionMove[nb, next, Cell, asf];
      ];
    
    (* are same but for practice sake *)
    
    (* w = 
          ToExpression[
            StringJoin[
              Characters[
                  str] /. {___, a : _ /; a == "[", y : __, 
                    b : _ /; b == "]", ___} -> y]];
      *)
    
    y = ToExpression[
        StringJoin[
          groupadjacent[
              Characters[
                str], ((DigitQ[#1] && 
                        DigitQ[#2]) || (\[Not] DigitQ[#1] && \[Not] 
                          DigitQ[#2]) &), true][[2]]]];
    
    z = ToExpression[StringJoin[Select[Characters[d], DigitQ]]];
    
    (* see jutils tips above , scan and Table would be ok *)
    
     w = z - y;
    g = $Line + 2; 
     h = $Line + w + 1;
    
    (* forget using w ... 
         for some reason front end doesn't sync In labels  
         until after this module exits so no guess can work
      *)
    
    SelectionMove[nb, After, EvaluationCell];
    
    "inputs seen back=" <> ToString[b] <> " inputs exec'ed=" <> ToString[a] <>
       " tot. lines=" <> ToString[i] <> " old " <> " In[" <> ToString[y] <> 
      "] to In[" <> ToString[z] <> "]" <> " guessing " <> " In[" <> 
      ToString[g] <> "] to In[" <> ToString[h] <> "]"
    
    ]
(*
Private
*)
Begin["`Private`"];
(*
Expr
*)
(*
padit
*)
padit[v_, pad_] := StringJoin[PadRight[Characters[ToString[v]], pad, " "]]
paditl[v_, pad_] := StringJoin[PadLeft[Characters[ToString[v]], pad, " "]]
paditc[v_, pad_] := Module[{si, sf, n, m},
    n = pad + 1;
    si = v;
    m = StringLength[si];
    While[--n >= 1 && m < pad,
      m = m + 1;
      sf = padit[si, m];
      m = m + 1;
      If[m > pad, Return[sf]];
      If[sf != si, si = paditl[sf, m]];
      If[sf === si, m = pad, m = StringLength[si]];
      ];
    si
    ]
(*
ToEach
*)
(*
(* SetAttributes[ToEach2,HoldRest] *)
*)
ToEach2[a_, b_] := 
  Module[{i}, Table[{a[[i]], Evaluate[b]}, {i, 1, Length[a]}]]
(*
(* SetAttributes[ToEach3,HoldRest] *)
*)
ToEach3[a_, b_] :=
  Module[{v}, a + v /. {Plus -> List, v -> b}]
(*
(* SetAttributes[ToEach,HoldRest] *)
*)
ToEach[a_, b_] := Map[ ({#, b} &), a]
(*
list
*)
SetAttributes[{list, listc}, Listable];
(*
Use [any] function as Listable
*)
list[ff_Symbol, i_] := ff[i];
(*
example , map vars to fun print
*)
(*
(* vars = {"i", "j", "ffun", "fdo"} *)
*)
(*
(* list[Print, vars] *)
*)
(*
example , apply against vars in context
*)
(* OLD ? listc[ff_Symbol, str_String] := list[Evaluate[Names[str]], ff]; *)
listc[ff_Symbol, str_String] := list[ff, Evaluate[Names[str]]];
(*
(* listc[Print, "Global`*"] *)
*)
(*
listc is very similar to
*)
(*
(* Map[Print, Names["Global`*"]] *)
*)
(*
jr
*)
jr[m_:0] := Module[{a, b, c, data, asf, nb, where},
      asf = AutoScroll -> False; where = 0;
      If[IntegerQ[jmark] === False, jmark = 1];
      If[m =!= 0, where = m, where = jmark];
      If[where == 0, Print["where?"]; Return[]];
      nb = SelectedNotebook[];
      SelectionMove[nb, Previous, EvaluationCell, asf];
      SelectionMove[nb, All, CellContents, asf];
      SelectionMove[nb, All, Word, asf];
      data = NotebookRead[nb];
      If[data /. BoxData[x : _] -> x == "jr",
        SelectionMove[nb, All, Cell, asf];
        NotebookDelete[nb];
        NotebookLocate[ToString[where]];
        ];];
(*
jm
*)
jm[m_:0] := Module[{a, b, c, data, asf, nb, where},
      asf = AutoScroll -> False;
      If[IntegerQ[jmark] === False, jmark = 0];
      If[m =!= 0, where = m, ++jmark; where = jmark];
      nb = SelectedNotebook[];
      (* pt. after output cell *)
      
      SelectionMove[nb, After, EvaluationCell, asf];
      SelectionMove[nb, Next, Cell, asf];
      SelectionMove[nb, All, Cell, asf];
      data = NotebookRead[nb];
      (* note use -> not -> *)
      
      c = ToExpression["CellTags->\"" <> ToString[where] <> "\""];
      data2 = data /. Cell[a : __, b : _] -> Cell[a, b, c];
      NotebookWrite[nb, data2]; 
      (* normal placement *)
      (* 
        SelectionMove[nb, After, EvaluationCell];*)
      
      SelectionMove[nb, Previous, EvaluationCell, asf];
      SelectionMove[nb, All, CellContents, asf];
      SelectionMove[nb, All, Word, asf];
      data = NotebookRead[nb];
      If[data /. BoxData[x : _] -> x == "jm",
        SelectionMove[nb, All, Cell, asf];
        NotebookDelete[nb];
        ];];
(*
Fsb
*)
(*
	for use with src/openMotif-n.n.n/demos/programs/fsb
*)
Fsb::usage = "Opens file dialog, returns string to stdout.";
ucc::usage = "rsh cmd output is /tmp/nbasktmpfile";
ucl::usage = "run cmd and ReadList output";
uci::usage = "run cmd and Import output";
(*
Fsb offers a "safe replacement" for opening files since "File->Open" filebox \
freezes front end for any wrong keystroke.
*)
(*
Fsb is to replace broken file box.  after error it ? drops stream (freezes) \
they said,  anywhow the box motif box isn't modal (can be hidden) but gets \
hidden and thus invisible and without input : thus mathematica is frozen \
waiting for input you cna't give it.  (all you see is the cursor , the box is \
actually still waiting for key)
*)
(*
there is some way to pass key to the hidden box i can't remember how at the \
moment
*)
Fsb[] := Module[{xfile, str, cmd},
    Run["echo \\\"$(fsb)\\\" > /tmp/nbasktmpfile"];
    xfile = OpenRead["/tmp/nbasktmpfile"];
    str = Read[xfile]; Close[xfile]; str]
(*
good news of OpenRead is it can Read n and Skip n and Close.  bad and good: \
it's baked.  experimental has binary.
*)
(*
more wack is "RunThrough" which refuses ? non-expressions as output but \
(won't) evalutate output that is expression
*)
(*
ucc
*)
(*
Is nice if one doesn't need to switch to xterm to create a file and switch \
back to Mathematica to read / show it.  With baked input and owned tty - not \
straight away.
*)
ucc[c_String, host_String:$MachineName] :=
    Module[{file, cmd},
      file = "/tmp/nbasktmpfile";
      cmd = 
        "rsh " <> host <> " '(" <> ". /etc/profile.small ; " <> c <> 
          " 2>>/dev/null > " <> file <> ")'";
      Run[cmd]];
(*
ucl
*)
ucl[c_String, host_String:$MachineName] :=
  Module[{xfile, str, file},
    file = "/tmp/nbasktmpfile";
    ucc[c, host];
    xfile = OpenRead[file];
    str = ReadList[xfile, String]; Close[xfile];
    str]
(*
ucl[c_String,host_String:"sol8"]:=Module[{xfile,str,file,cmd},
    file="/tmp/nbasktmpfile";
    cmd=c<>" > " <> file;
    Run[cmd];
    xfile=OpenRead[file];
    str=ReadList[xfile,String];Close[xfile];
    (*DeleteFile[file];*)
    str]
*)
(*
skip DeleteFile[file]
*)
(*
Streams[]
*)
(*
uci
*)
uci[c_String, host_:$MachineName] := Module[{file},
    file = "/tmp/nbasktmpfile";
    ucc[c, host]; Import[file, "Text"]]
(*
examples:
	uci["man -P cat cal"]
	ucl["ls | cols -w 25 -c 2"]
*)
(*
uci[c_String,host_String:"sol8"]:=Module[{str,file,cmd},
    file="/tmp/nbasktmpfile";
    cmd=c<>" 2>>/dev/null > " <> file;
    Run[cmd];Import[file,"Text"]]
*)
(*
cmd="/bin/bash -l -c '(. /etc/profile ; man -P cat cal 2>&1 > nbasktmpfile \
2>&1)'"
*)
(*
with above simple cmd, "man -P cat cal"  cannot run gzip likely as \
mathematica or shell it started from owns /dev/pty stdout and stderr , and no \
easy command , "due to tty improvements makeing tty no longer a file" , can \
attatch.  rsh(1) does it.
*)
(*
NbAskOpen
*)
(*
(*"" opens an empty notebook*)
*)
NbOpenAsk[] := Module[{xfile}, xfile = Fsb[];
    If[xfile != "", NotebookOpen[xfile], $Failed]]
(*
Increments
*)
(*
incase calendar didn't load ...\[Not]NameQ["IncrementToward"] is a pain
*)
(*
IncrementToward[y_, x_] := If[(y >= 0 && x > y) || (y <= 0 && x > y), x - 1,
    If[x =!= y, x + 1, x]
    ]
*)
(*
IncrementAway[y_, x_] := If[(y >= 0 && x > y) || (y <= 0 && x > y), x + 1,
    If[x =!= y, x - 1, x + Sign[x]]
    ]
*)
(*
IncrementAwayAbove[y_, x_] := 
  If[(y >= 0 && x > y) || (y <= 0 && x > y), x + 1,
    If[x =!= y, x - 1, x + 1]
    ]
*)
(*
IncrementAwayBelow[y_, x_] := 
  If[(y >= 0 && x > y) || (y <= 0 && x > y), x + 1,
    If[x =!= y, x - 1, x - 1]
    ]
*)
(*
mag
*)
mag[r_] := (Plus @@ (r^2))^(1/2);
(*
unit
*)
unit[r_] := Module[{mr}, mr = mag[r]; If[mr === 0, 0, r/mr]];
(*
midpt
*)
midpt[r_] := Module[{mr}, lr = Length@r; If[lr === 0, 0, Plus @@ (r)/lr]];
(*
BrowserCategory
*)
(*
Browser Categories
*)
(*
note after evaluating, if saving, "bump" (use enter) the cell to get rid of \
the cell tag before saving (see notes at top)
*)
(*
save this as 
	~/.Mathematica/4.0/AddOns/Applications/jutils/Documentation/English
unsure if .nb can be pointed outside
*)
(* written by : was - help.nb in chem/ *)
browsercategory = BrowserCategory[
      
      "jutils"
      , None
      , {
        
        Item[
          "Top"
          , "jutils.help.nb"
          , CopyTag -> "S1.0.0"
          , IndexTag -> "1.1"
          ]
        
        , Item[
          "jm / jr"
          , "jutils.help.nb"
          , CopyTag -> "S1.1.1"
          , IndexTag -> "1.1"
          ]
        
        , Item[
          "mod v. pack"
          , "jutils.help.nb"
          , CopyTag -> "S1.2.1"
          , IndexTag -> "1.1"
          ]
        
        , Item[
          "symbolics"
          , "jutils.help.nb"
          , CopyTag -> "S1.3.1"
          , IndexTag -> "1.1"
          ]
        
        , Item[
          "CreateModule"
          , "jutils.help.nb"
          , CopyTag -> "S1.4.1"
          , IndexTag -> "1.1"
          ]
        
        , Item[
          "RunTo"
          , "jutils.help.nb"
          , CopyTag -> "S1.4.2"
          , IndexTag -> "1.1"
          ]
        
        , Item[
          "CombineCells"
          , "jutils.help.nb"
          , CopyTag -> "S1.5.1"
          , IndexTag -> "1.1"
          ]
        
        , Item[
          "reminders / tips"
          , "jutils.help.nb"
          , CopyTag -> "S1.6.1"
          , IndexTag -> "1.1"
          ]
        
        , Item[
          "fNBookForm"
          , "jutils.help.nb"
          , CopyTag -> "S1.7.1"
          , IndexTag -> "1.1"
          ]
        
        , Item[
          "Periodic Table of Elements"
          , "jutils.help.nb"
          , CopyTag -> "S1.8.1"
          , IndexTag -> "1.1"
          ]
        
        }];
browsercategory >> "~/jutils/BrowserCategories.m"
(*
browsercategory >> \
"~/.Mathematica/4.0/AddOns/Applications/jutils/Documentation/English/\
BrowserCategories.m"
*)
Remove[browsercategory];
(*
EndPackage
*)
End[];
On[General::"spell"];
EndPackage[];
(*
etc
*)
(*
context resolving worksheet -- which x ??
*)
(*
	result :  there's no way to use "x" as shorthand
		without clobbering and weird goings on
*)
(*
	To use "x" it can NOT already be under any $ContextPath
		(unless you intend environment change of some Package)
	m`x  is always OK , and m`n`x is safe
		m`x is x of all first nodes of $ContextPath UNTIL
		other`x   is set anywhere - then other`x is x in all nodes
	if $ContextPath is removed all functions dissapear , not good
*)
(*
*  in general : only use "x" if it's "being watched" appropriately, see "why \
not to try" below
*)
(*
$Packages
*)
(*
Context[$ContextPath]
*)
(*
BeginPackage sets things up so that only System` and the named context are in \
the context search path. EndPackage undoes this and adds name to path.
	{name`,{name`,System`}}
	`jutils`x in Context[x] - if not shadowed
	but BoxForm`x is not
*)
(*
$Context - context variables are looked for in LAST or created in
$ContextPath - contexts to search symbols
	* but NOT Context names
	* non-recursive , sub-contexts are not found
Begin / End are simply push / pop
*)
(*
Context names are Temporary (dissapear) but $ContextPath does NOT follow \
that.  Additionally,  Global` can be remoeved / dissapes, but reappears / is \
default.
Context variables are temporary / are garbage collected
	HOWEVER - if shadowed the next variable 
	of same name in $ContextPath will be present
*)
(*
** important to keep in mind that entering $Context doesn't change \
$ContextPath , which means once "x" is defined in CP it shadows all $Context \
that do not push / pop $ContextPath
* keep in mind context names ARE NOT replaced ever : 
	n` is always a base node
	`n`x in n` -> Global`n`n`x
	`n` in Global -> Global`n`x
context adds $NewSymbol as appropriate , per say
*)
(*
*  why not to try : if careful and vars are created with NO $ContextPath then \
context is set first in path (which Mathematica does not do) then , only if \
nothing sets any of these , shorthand can be used.  But if $ContextPath is \
not restored due to error that might be or become bad.
	System`$ContextPath={"Global`","System`"}
Note that doesn't restore what had been , and wouldn't unless pushed and \
popped in System , and who knows what happens before it's found out or if \
[session] could be lost or very difficult.
*)
(*
orig = Contexts[];
*)
(*
Remove[x, m`x, n`x, `n`x]
*)
(*
Begin["m`"]
*)
(*
{$Context, $ContextPath}
*)
(*
DO NOT USE: is Global`x or m`x
*)
(*
x = 1
*)
(*
Context[x]
*)
(*
End[]
*)
(*
{$Context, $ContextPath}
*)
(*
x = 2
*)
(*
{m`x, x}
*)
(*
Complement[Contexts[], orig]
*)
(*
  -----------------------------------------------------------
*)
(*
Remove[x]
*)
(*
Begin["`n`"]
*)
(*
{$Context, $ContextPath}
*)
(*
Complement[Contexts[], orig]
*)
(*
DO NOT USE: is Global`x or Global`n`x
*)
(*
x = 3
*)
(*
Context[x]
*)
(*
Complement[Contexts[], orig]
*)
(*
n`x = 4
*)
(*
Complement[Contexts[], orig]
*)
(*
`n`x = 5
*)
(*
Complement[Contexts[], orig]
*)
(*
Global`n`x = 6
*)
(*
Complement[Contexts[], orig]
*)
(*
Context[x]
*)
(*
End[]
*)
(*
{$Context, $ContextPath}
*)
(*
{m`x, x, Global`x, Global`n`x, `n`x, n`x, Global`n`n`x}
*)
(*
Complement[Contexts[], orig]
*)
(*
Remove[x, m`x, n`x, `n`x, `n`n`x]
*)
(*
Complement[Contexts[], orig]
*)
(*
  -----------------------------------------------------------
*)
(*
      part 2 , x is left in Global` before defnitinos
*)
(*
  -----------------------------------------------------------
*)
(*
Remove[x, m`x, n`x, `n`x, `n`x]
*)
(*
x = 2
*)
(*
Begin["m`"]
*)
(*
{$Context, $ContextPath}
*)
(*
DO NOT USE: is Global`x or m`x
*)
(*
x = 1
*)
(*
Context[x]
*)
(*
End[]
*)
(*
{$Context, $ContextPath}
*)
(*
x = 2
*)
(*
{m`x, x}
*)
(*
Complement[Contexts[], orig]
*)
(*
  -----------------------------------------------------------
*)
(*
Begin["`n`"]
*)
(*
{$Context, $ContextPath}
*)
(*
Complement[Contexts[], orig]
*)
(*
DO NOT USE: is Global`x or Global`n`x
*)
(*
x = 3
*)
(*
Context[x]
*)
(*
$Context
*)
(*
Complement[Contexts[], orig]
*)
(*
n`x = 4
*)
(*
Complement[Contexts[], orig]
*)
(*
`n`x = 5
*)
(*
Complement[Contexts[], orig]
*)
(*
Global`n`x = 6
*)
(*
Complement[Contexts[], orig]
*)
(*
Context[x]
*)
(*
End[]
*)
(*
{$Context, $ContextPath}
*)
(*
{m`x, x, Global`x, Global`n`x, `n`x, n`x, Global`n`n`x}
*)
(*
Complement[Contexts[], orig]
*)
(*
======================
*)
(*
note  n`  is a level with Global` despite stated within `n`
*)
(*
======================
*)
(*
(* Remove[x, m`x, n`x, `n`x, `n`n`x] *)
*)
(*
(* Complement[Contexts[], orig] *)
*)
(*
Remove[m`x, `n`x, `n`n`x]
*)
(*
{m`x, x, Global`x, Global`n`x, `n`x, n`x, Global`n`n`x}
*)
(*
Remove[m`x, `n`x, `n`n`x]
*)
(*
Complement[Contexts[], orig]
*)
(*
Remove[x, n`x]
*)
(*
{m`x, x, Global`x, Global`n`x, `n`x, n`x, Global`n`n`x}
*)
(*
Remove[x, m`x, n`x, `n`x, `n`n`x]
*)
(*
Complement[Contexts[], orig]
*)
(*
{{Names["m`*"]}, {Names["n`*"]}, {Names["`n`*"]}, {Names["n`n`*"]}, {Names[
      "`n`n`*"]}}
*)
(*
Development Notes for CreateModule
*)
(*
this line had stripped context names only from variables.  this probably \
doesn't help anything.
*)
(*
vars2 = Map[(StringReplace[#, context2 -> ""] &), Names[con2]];
*)
(*
this would be perfect to remove c`p` but Names already excludes it for us
*)
(*
Select[{"c1`p`x", "c1`x"}, (\[Not] StringMatchQ[#, "c1`p`*"] &)]
*)
(*
2.10.3
*)
(*
The 2D array dimensions for array Module are very picky for "module" \
(evaluate parser must group by / collect between [] , thus nested boxing, but \
boxes inside must not be unecessarily nested : see CombineCells dev. notes )

	Evaluate will freeze if it is not jsut so :
*)
(*
C [ B [ R1 [{ Rh [{ hd , Rm [ { mod , Ra [ {  Rb [ { VARS , BODY }]b  }]a  
, "\n" , endmod  }]m  }]h  , ";" }]1  ]b , "Input" ]c
*)
(*
at first think "drop the hd := Mod" and return Definition.  but that will not \
help (see notes for CombineCells)
*)
(*
C [ B [ R1 [{ 
	Rh [{ 	hd , ":=", 
		Rm [ { mod , 
			Ra [ {  Rb [ { VARS , BODY }]b  }]a  
			, "IndentingNewLine" , endmod  
		}]m  
	}]h  , ";"
}]1  ]B , "Input" ]
*)
(*
Somehow CreateModules gets an IndentingNewLine after Body that doesn't come \
from CombineCells.  (likely from Rowbox[x] ).  So where it is above it's \
omitted and looks the same.  Should be ok fine.
*)
(*
Development Notes for CombineCell
*)
(*
First note that Boxes etc are in a Notebook deal with Standard Form boxes \
which represent expressions but also decorations (ie, comments) or text.  \
(ie, RowBox) and not FullForm.
*)
(*
Anything using the result of combining cells doesn't need "extra problems" to \
do.  The below notes 2 things Combine Cells does to provide a cleaner result.
*)
(*
---------------------------------------
*)
(*
Step 1.  First note NotebookRead will get : 
	"Cell [ BoxData [ RowBox [{ RowBox [{ RowBox [{ data .}] , extra }]  }] ]"
CombineCells wants :
	"{ RowBox [{ data }]  , extra }"
	
note that's "

assuming one RowBox is needed to wrap expr (a single expr / line in a \
module).  That part is solved by simple indexing and the \
"Length[Position[data2,RowBox]]>1" check.  Because a final wrapper is places \
for all lines combined the extras are not left unboxed.

See below for more about extra wrapping and problems that occur with it.  \
(improper evaluation and or Kernel freeze / disconnect to Front End )
*)
(*
---------------------------------------
*)
(*
Step 2.  HOWEVER.
*)
(*
To work with more trivial examples of combining lines NotebookRead leaves \
another problem ... (and I hope not worse or more !)
*)
(*
The Front End does "nesting of compound expressions" (nesting of RowBoxes) \
and it can display that in 2D (but this isn't evalutation).  For a single \
cell and expr this works and is stored in the Notebook that way.  But for a \
cell with compound expressions in a cell the Front End actually undoes the \
nesting as you edit BEFORE it's stored and or evaluated , and then stores it \
not nested.  Hmm.
*)
(*
Unfortunately if one wishes to Combine lines one is left with undoing the \
nesting "shoft hand" the Front End has left and there is no Mathematica \
documented way I know that undoes this.  Note "FromBoxes" combined with \
"ToExpression" will not work since ToExpression requires evaluation which , \
due to shorthand and that FromBoxes is not made to undo it: can't and doesn't \
work as is.  And if made to (after step 1above) and were protected from \
evaluating : all decorators are removed so the result is then unusable \
further except as .mx source.
*)
(*
ANSWER:
*)
(*
Modules are made of a line (or lines using "\n") of compound expressions , \
these are completely determined by placement of the Compound Expression \
operator ";"

Compound expressions within Module must not use a RowBox wrapper to wrap the \
compound expression operator ";"  
	BAD: { RowBox[{ RowBox[{ "y" }] , ";" }] }
		NOTE ";" is within an outermost box but outside box it applies to.
		This is ok for one cell but when combining cells it can't be used.
		It isn't as simple as removing it , see why below.
	GOOD : { RowBox[{ "x" }] , ";" }
		this can be combined and an outer RowBox added to all
	and NOTE the {} the parens (added) are needed when matching
*)
(*
Problem is, for CombineCells , that for a single Cell the Front End can and \
will "wrap" (bad) expr and comound separator whenever there is anything \
intervening the expr and compound expr operator.  That's frequently: it \
includes white space, comments , anything.
	not wrapped: "expr1;expr2;expr3;"
	get wrapped: "expr1 ; expr2 ; expr3 ;"
*)
(*
This hopefully does more good than bad  ...
	a,  anything preceeding compound expr
	b,  the expr
	h, anything preceeding compound expr separator ";"
	d, anything after compound expr separator ";"
*)
(*
	data /.
	{a:___,RowBox[{RowBox[{b:___}],h:___,y:";",d:___}],c:___}->
	{a,RowBox[{b}],y,h,d,c}
*)
(*
The rule above rewrites "bad to good".  Hopefully it does no harm to \
structures which might un-intentionally match.  (if so, add ex, \
b:___/;b!=what)
*)
(*
If one combines cells manually (using Show Expression) and edites it with the \
Front End one sees the front end keeps bad but when any editing occurs \
rewrites it : even if the editing result changes nothing (add return then \
remove it) it is restructured to undo the nesting.

Infact it isn't as if the Front End never has problems.  When working with \
edited modules the Front End sometime create an error box that replaces one's \
ORIGIONAL SOURCE with red underlined junk ... which in effect deletes one's \
un-saved work !
*)
(*
Finally.  What is more suble.  The Kernel does use nesting of expression for \
If , Table, Function[x_]:=y, Module, etc, which are exceptions looked for, \
and if they are wrapped in boxes when handed to ToExpression the nesting of \
boxes shouldn't be confused with the nesting of expressions.  (exceptions are \
grouping [] , lists read and interpreted with special meaning, etc)

Finally, to add possible confusion, Mathematica input forms do not \
generically see nesting as boxing :
	ToExpression["\(x\^y\^x\^z\)"] 	nest boxes x^y^z
	ToExpression["\(x\^y \(x^z\) \)"] 	unboxes x^z
	ToExpression["\(x\^y\^\(x^z\) \)"] 	is x^y^(x^z unboxed)
the nested textform box expression un-boxes x^z (it does not nest-box it as \
one might think).
*)
(*
ToExpression["\(x\^y\^x\^z\)"]
*)
(*
SuperscriptBox["x", SuperscriptBox["y", SuperscriptBox["x", "z"]]]
*)
(*
ToBoxes[Unevaluated[
    Module[{x}, Print["bob"] ; (*x*)Print["bib"];];
    ]]
*)
(*
RowBox[{RowBox[{"Module", "[", 
        RowBox[{RowBox[{"{", "x", "}"}], ",", 
            RowBox[{RowBox[{"Print", "[", "\"bob\"", "]"}], ";", 
                RowBox[{"Print", "[", "\"bib\"", "]"}], ";"}]}], "]"}], ";"}]
*)
(*
RowBox[{RowBox[{"Module", "[",
        RowBox[{
            	RowBox[{"{", "x", "}"}], ",",
            	RowBox[{
                	RowBox[{"Print", "[", "\"bob\"", "]"}], ";",
                	RowBox[{"Print", "[", "\"bib\"", "]"}], ";"
                	}]
            }]
        , "]"}], ";"}]
*)
(*
ToExpression[%]
*)
(*
"bob"
*)
(*
"bib"
*)
(*
wtth respece ot outer box the ";" are outside expr they separate.  however if \
(*x*) had not been deleted the "simple way" will not work.
*)
(*
RowBox[{RowBox[{"Module", "[",
        RowBox[{
            	RowBox[{"{", "x", "}"}], ",",
            	RowBox[{
                	RowBox[{	
                      	RowBox[{"Print", "[", "\"bob\"", "]"}], ";", " "}]
                  	RowBox[{"Print", "[", "\"bib\"", "]"}], ";"
                	}]
            }]
        , "]"}], ";"}]
*)
(*
RowBox[{RowBox[{"Module", "[", 
        RowBox[{RowBox[{"{", "x", "}"}], ",", 
            RowBox[{RowBox[{RowBox[{"Print", "[", "\"bob\"", "]"}], ";", 
                      " "}] RowBox[{"Print", "[", "\"bib\"", "]"}], ";"}]}], 
        "]"}], ";"}]
*)
(*
ToExpression[%]
*)
(*
Syntax::"sntxb": "Expression cannot begin with \"\!\(\(\(\(\((\(\(Print[\"bob\
\"]\)\) ;\\ )\)\)\\ \(\(Print[\"bib\"]\)\)\)\) ;\)\".\!\(\"\"\)"
*)
(*
ToExpression::"esntx": "Could not parse \
\!\(RowBox[\(\({\(\(RowBox[\(\({\"Module\", \"[\", \(\(RowBox[\(\({\(\
\[LeftSkeleton] 1 \[RightSkeleton]\)}\)\)]\)\), \"]\"}\)\)]\)\), \
\";\"}\)\)]\) as Mathematica input."
*)
(*
$Failed
*)
(*
The above is fails due the a single white space not due to the whitespace but \
due to the way it would be wrapped when read by NotebookRead.
*)
(*
boxes = ToBoxes[Unevaluated[
        
        RowBox[{Module, "[",
            RowBox[{"{", "x", "}"}], ",",
            RowBox[{
                RowBox[{RowBox[{Print, "[", "bob", "]"}], ";"}], "\n", " "
                ,
                RowBox[{RowBox[{Print, "[", "bob", "]"}], ";"}], " "
                }]
            , "]"}]
        
        ]];
*)
(*
cell = Cell[BoxData[ToExpression[boxes]], "Input"];
*)
(*
General::"spell1": "Possible spelling error: new symbol name \"\!\(cell\)\" \
is similar to existing symbol \"\!\(Cell\)\"."
*)
(*
CellPrint[cell];
*)
(*
Module[{x}, Print[bob];
 Print[bob]; ]
*)
(*
bob
*)
(*
bob
*)
(*
\!\(Null\^2\)
*)
(*
The above fails to evaluate correctly becuase ToBoxes does not "undo" the \
nesting of ";".
*)
(*
Remove[boxes, cell, x, y]
*)
(*
P.S.  for interest , another exception to expr 2D appearance v. evaluation is \
how boxes and operators map to Function , and here is one way 2D and \
evaluation are revealed :
*)
(*
InterpretationBox[SuperscriptBox["x", "2"], Plus[x, 2]] // DisplayForm
*)
(*
x\^2
*)
(*
ToExpression[%]
*)
(*
2 + x
*)
(*
see Section 2.8.17 about MakeExpression, MakeBoxes , ToBoxes, ToExpression, \
Format, StringForm, SequenceForm, Infix and precedencee, ...
*)
(*
This is interesting and can be inserted before Rule in the While loop.  \
However cannot be directly used.  It's also "low level" and may require low \
level details on a per case basis (ie, for If[] ).

data3=ToString[MakeExpression[RowBox[data2],StandardForm]];
Print[ToString[data3]];
data3=ToString[MakeBoxes[data3,StandardForm]];
Print[ToString[data3]];

OOPS ... going from MakeBoxes to MakeExpression is easy.  However going the \
other way around is completely wacked out.  MakeExpression from Notebook is a \
Sequence held by HoldComplete containing fluff , Nulls, and expressions \
intermixed - needing to be "undone".

Often the Mathematica book shows the slide toward the bottom of the hill in \
it's Examples.
*)
